/**
 * Configures Pitaya Framework
 */
export declare class PitayaConfiguration
{
	/**
	 * Indicates if the plugin is already initialized.
	 */
	public initialized: boolean;

	/**
	 * Class on <body> which is applied if development is enabled.
	 */
	public readonly devBodyClass: string;

	/**
	 * Determines if development is enabled.
	 */
	public readonly development: boolean;

	/**
	 * Enables development. Optionally sets the devBodyClass.
	 */
	public enableDevelopment( bodyMarkerClass?: string ): void;
}