import { Container } from "aurelia-framework";

export declare class PitayaView
{
	/**
	 * Inner HTML element which holds the actual content.
	 * Also the <slot> content gets projected there.
	 */
	public readonly innerElement: HTMLElement;

	/**
	 * @bindable
	 * Prevents scrolling
	 */
	public noScrolling: boolean;

	/**
	 * @bindable
	 * Prevents user from interacting with this custom element and all of its child components.
	 */
	public noInteraction: boolean;

	/**
	 * @bindable
	 * Event callback - Gets called when the view transition animation has been completed.
	 */
	public onAnimated: ( component: PitayaView ) => void;

	/**
	 * @bindable
	 * Event callback - Gets called when this custom element and its child elements have been fully loaded.
	 */
	public onReady: ( component: PitayaView ) => void;

	/**
	 * Scrolls to a secific position or element.
	 */
	public scrollTo( target: number | HTMLElement, offset?: number ): void;
}