var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { autoinject } from "aurelia-dependency-injection";
import { PLATFORM, TaskQueue, viewResources } from "aurelia-framework";
import { bindable } from "aurelia-typed-observable-plugin";
const VIEW_ACTIVE_LEAVE_CLASS = "au-leave-active";
let PitayaView = class PitayaView {
    constructor(_rootElement, _queue) {
        this._rootElement = _rootElement;
        this._queue = _queue;
        this._animationReady = false;
    }
    get innerElement() {
        return this._innerElement;
    }
    scrollTo(target, offset = 16) {
        const viewElement = this._rootElement;
        const position = target instanceof HTMLElement ? Math.max(0, target.offsetTop - offset) : target;
        viewElement.scrollTo({
            behavior: "smooth",
            left: 0,
            top: position
        });
    }
    attached() {
        this._setAnimationListener();
        this._queue.queueMicroTask(() => {
            this.onReady && this.onReady({ component: this });
        });
    }
    _willBeAnimated() {
        const siblings = [...this._rootElement.parentElement.children];
        return siblings.some(sibling => sibling !== this._rootElement && sibling.classList.contains(VIEW_ACTIVE_LEAVE_CLASS));
    }
    _setAnimationListener() {
        if (!this._willBeAnimated()) {
            this._onAnimationEnd();
            return;
        }
        this._rootElement.addEventListener("animationend", this._onAnimationEnd.bind(this), { once: true });
    }
    _onAnimationEnd() {
        this._animationReady = true;
        this.onAnimated && this.onAnimated({ component: this });
    }
};
__decorate([
    bindable,
    __metadata("design:type", Boolean)
], PitayaView.prototype, "noScrolling", void 0);
__decorate([
    bindable,
    __metadata("design:type", Boolean)
], PitayaView.prototype, "noInteraction", void 0);
__decorate([
    bindable,
    __metadata("design:type", Function)
], PitayaView.prototype, "onAnimated", void 0);
__decorate([
    bindable,
    __metadata("design:type", Function)
], PitayaView.prototype, "onReady", void 0);
PitayaView = __decorate([
    autoinject,
    viewResources(PLATFORM.moduleName("./pitaya-view.css")),
    __metadata("design:paramtypes", [Element,
        TaskQueue])
], PitayaView);
export { PitayaView };

//# sourceMappingURL=pitaya-view.js.map
